﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
Sub Class_Globals
	Private Const PAUSE_I 		As Int = 0
	Private Const RUN_I			As Int = 1
	Private Const CHEKPOINT_I 	As Int = 2
	Private Const SHUTDOWN_I 	As Int = 3
	Private Const GET_DATA_I 	As Int = 4
	
	Private Const PAUSE_S 		As String = "Pause"
	Private Const RUN_S			As String = "Run"
	Private Const CHEKPOINT_S 	As String = "Checkpoint"
	Private Const SHUTDOWN_S 	As String = "Shutdown"
	Private Const GET_DATA_S 	As String = "GetData"
	
	Private Const STATUS_OK  As Int = 0
	Private Const STATUS_ERROR  As Int = 1
	
	Private cmdWrite As cmdData_t
	Private cmdRead  As cmdData_t
	
	Private Astream As AsyncStreams
	Public IsConnected As Boolean
	Private ser As B4XSerializator
	Private socket As Socket
	Private tmr As Timer
End Sub



'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	cmdRead.Initialize
	cmdWrite.Initialize
	tmr.Initialize("tmr", 2000)
	tmr.Enabled = True
	SetState(False)
End Sub


'============================================================================================
Private Sub SetState(connected As Boolean)
	IsConnected = connected
	If IsConnected Then
'		lblState.Text = "State: Connected"
	Else
'		lblState.Text = "State: Disconnected"
	End If
End Sub


'============================================================================================
Private Sub Astream_NewData(buffer() As Byte)
	Try
		cmdRead = ser.ConvertBytesToObject(buffer)
	Catch
		Log(LastException)
	End Try

	Log(("Read Data: " & cmdRead.cmd & " - " & cmdRead.cmdName & "Status: " & cmdRead.status & "  Date: " & cmdRead.dt))
	
	'Debug only
	cmdWrite.cmd = cmdRead.cmd
	cmdWrite.cmdName = cmdRead.cmdName
	cmdWrite.status = STATUS_OK
	cmdWrite.dt = DateTime.Now
	'------------------------------
	
	Select cmdRead.cmd
		Case PAUSE_I
			

		Case RUN_I
			
		Case CHEKPOINT_I
			
		Case SHUTDOWN_I
			'Setup return message
			astreamWriteData
			
			Sleep(5000)
			
			'Exit app
			ExitApplication
			
		Case GET_DATA_I
			Dim nowTime As Long
			nowTime = DateTime.Now
			
			cmdWrite.jDate = _
				jdt.calendarIntToJulianDateTime(DateTime.GetMonth(nowTime), _
												DateTime.GetDayOfMonth(nowTime), _
												DateTime.GetYear(nowTime), _
												DateTime.GetHour(nowTime), _
												DateTime.GetMinute(nowTime), _
												DateTime.GetSecond(nowTime), _
												0) 	
			
			cmdWrite.Freq 				= 50 	+ Rnd(-1, 1)
			cmdWrite.Vrms 				= 220 	+ Rnd(-20, 20)
			cmdWrite.ProcessorTemp 		= 42.5 	+ Rnd(-10, 10)
			cmdWrite.mainBatteryVolts 	= 13.64 + Rnd(-1, 1)
			cmdWrite.Quality 			= 0 	+ Rnd(0, 100)
			cmdWrite.dt 				= DateTime.Now
	End Select
	astreamWriteData
End Sub



'============================================================================================
Private Sub astreamWriteData
	Astream.Write(ser.ConvertObjectToBytes(cmdWrite))
	Log(("Write Data: " & cmdWrite.cmd & " - " & cmdWrite.cmdName & "Status: " & cmdWrite.status & "  Date: " & cmdWrite.dt))
End Sub


'============================================================================================
Private Sub Astream_Terminated
	SetState(False)
	If Astream.IsInitialized Then
		Astream.Close
	End If
		
	If socket.IsInitialized Then
		socket.Close
	End If
End Sub


'============================================================================================
Private Sub Astream_Error
	Astream_Terminated
End Sub


'============================================================================================
Public Sub StateChanged
	If IsConnected Then
'		lblState.Text = "  State: Connected"
	Else
'		lblState.Text = "  State: Disconnected"
	End If
End Sub


'============================================================================================
private Sub tmr_Tick
	If (socket.Connected) = False Then
		If Astream.IsInitialized Then
			Astream.Close
		End If
		
		If socket.IsInitialized Then
			socket.Close
		End If
		
		socket.Initialize("socket")
		socket.Connect("127.0.0.1", 17170, 0)
		Wait for socket_Connected(Successful As Boolean)
		If Successful Then
			SetState(True)
			Astream.InitializePrefix(socket.InputStream, True, socket.OutputStream, "astream")
		End If
	End If
End Sub


'============================================================================================
Public Sub ConnectSocket
	SetState(False)
	If Astream.IsInitialized Then
		Astream.Close
	End If
	
	If socket.IsInitialized Then
		socket.Close
	End If
	socket.Initialize("socket")
	socket.Connect("127.0.0.1", 17170, 0)
	Wait for socket_Connected(Successful As Boolean)
	If Successful Then
		SetState(True)
		Astream.InitializePrefix(socket.InputStream, True, socket.OutputStream, "astream")
	End If
End Sub
