﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=5.82
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
'	Dim xui As XUI

	Public logOn As Boolean
	
	'----------------------------------------------------------------------------------------
	'Network Variables
	
	Public IsConnected As Boolean
	Public TCPSocket As Socket
	Public tcpStream As AsyncStreams
	Public bypassTCPSteamProcessing As Boolean
	Public acqRestartFlag As Boolean
	
	Public noServerRequests As Long
	Public noServerErrors   As Long
	
	Type NWrkRecord_t(ssid As String, securityType As String, signalStrengthdB As Float, saved As Boolean)
	'    Dim NWrkRec As NWrkRecord_t
	
	Public NWrkRealTimeDataTmr As Timer
	Public CmdTimeoutTmr As Timer
'	Dim NetworkErrorBeepTmr As Timer
'	Dim AlarmWatchTmr As Timer
	
	Dim NWrkTransactionInProgress As Boolean
	Dim networkDown As Boolean
	
	Dim tempDouble(2) As Double
	Dim tempFloat(14) As Float
	Dim jTime As Double
	Dim calDate As calender_t
	
	Dim startTime As String
	Dim endTime As String
	
	Dim lastDataJulianDate As Double
	
	Public TCPConvRx As ByteConverter
	Public TCPConvTx As ByteConverter
	
	#if Debug
		Dim Const ipAddress = "192.168.1.111" As String	
		Dim Const psmDB_Filename = "psmdb_winSvr_Test.db"  As String
		Dim Const dbPath = "G:/PSM_Server_DB/" As String
	#else
		Dim Const ipAddress = "192.168.1.111" As String
		Dim Const psmDB_Filename = "psmdb_winSvr.db" As String
	#end if
	
	Dim Const port 		= 49152 As Int
	Dim Const passCode  = "1E28EC57" As String
	Dim passcodeInt As Int
	
	Dim passCodeByteArray(8) As Byte
	
	Dim Const  NW_OK = 0 As Int
	Dim Const  NW_ERROR = 1 As Int
	

	Dim txBuffGetRealTimePowerData(20) As Byte
	Public msgSerialNo As Int

	'----------------------------------------------------------------------------------------
	'Command Groups 		
	Dim Const GRP_NULL 						=   0 As Int
	Dim Const GRP_GET_INST_DATA 			=	1 As Int
	Dim Const GRP_SEND_CMD_NO_DATA 			=	2 As Int

	'Command Numbers Group 1                                                    */
	Dim Const CMD_1_NULL					=	0 As Int
	Dim Const CMD_1_GET_PWR_DATA			=	1 As Int
	Dim Const CMD_1_GET_PWR_DATA_LEN		=  116 As Int
	Dim Const CMD_1_GET_SYS_DATA			=	2 As Int

	'Command Numbers Group 2                                                    */
	Dim Const CMD_2_MOUNT_SD_CARD    		=	3 As Int
	Dim Const CMD_2_DISMOUNT_SD_CARD    	=	4 As Int
	
	'*************************************************************************************************************
	' Realtime data
	Dim const NO_SAMPLES = 3600 * 2 As Int
	
	Dim const MOV_AVG_NO_BINS = 10 * 60 * 0.5 As Int

	Public ptrIn As Short
	Public ptrOut As Short
	Public ptrMovAvg As Short
	Public movAvgStartCount As Short
	
	Public arrayJTimeEmbed(NO_SAMPLES) 	As Double
	Public arrayJTimeClient(NO_SAMPLES) As Double
	Public arrayFreq(NO_SAMPLES)  		As Double
	Public arrayVrms(NO_SAMPLES)  		As Double
	Public arraySupplykW(NO_SAMPLES)  	As Double
	Public arraySolarkW(NO_SAMPLES)  	As Double
	Public genLoadkW(NO_SAMPLES)  	As Double
	Public arrayQuality(NO_SAMPLES)  	As Double
	Public arrayMainBatVolts(NO_SAMPLES)  	As Double
	Public arrayCPUTemp(NO_SAMPLES)  	As Double
	
	Public Quality As Float
	
	Public maxV As Float
	Public minV As Float
	
	Public maxF As Float
	Public minF As Float
	
	Public maxSupplykW As Float
	Public minSupplykW As Float
	
	Public maxSolarkW As Float
	Public minSolarkW As Float
	
	Public maxLoadkW As Float
	Public minLoadkW As Float
	
	Public maxQuality As Float
	Public minQuality As Float
	
	'Moving average - FIR Filter Arrays
	Public arrayAvg_Vrms(MOV_AVG_NO_BINS) As Float
	Public arrayAvg_Freq(MOV_AVG_NO_BINS) As Float
	Public arrayAvg_P1(MOV_AVG_NO_BINS) As Float
	Public arrayAvg_P2(MOV_AVG_NO_BINS) As Float
	Public arrayAvg_P3(MOV_AVG_NO_BINS) As Float
	Public arrayAvg_Quality(MOV_AVG_NO_BINS) As Float
	Public arrayAvg_MainBattVolts(MOV_AVG_NO_BINS) As Float
	Public arrayAvg_ProcessorTemp(MOV_AVG_NO_BINS) As Float
	
	Public Const Q_FREQUENCY 	= 0x01 As Byte
	Public Const Q_VRMS 		= 0x02 As Byte
	Public Const Q_I1 			= 0x04 As Byte
	Public Const Q_I2 			= 0x08 As Byte
	Public Const Q_I3 			= 0x10 As Byte

	'*********************************************************************************
	' Realtime data
	#Region  realtimeSataStruct	
	Type rtData_t(	CommandGroup		As Int, _
					CommandNum			As Int, _
					jTimeEmbed			As Double, _
					Frequency 			As Double, _
					Vrms 				As Float, _
					RoCoF 				As Float, _
					RoCoVrms			As Float, _
					I1rms 				As Float, _
					I2rms 				As Float, _
					I3rms 				As Float, _
					P1 					As Float, _
					P2 					As Float, _
					P3 					As Float, _
					Q1 					As Float, _
					Q2 					As Float, _
					Q3 					As Float, _
					CPUTemp       		As Float, _ 	
					MainBatVolts       	As Float, _ 	
					flashMemError       As Byte, _
					freqMeasRefClkError As Byte, _
					realTimeProcError  	As Byte, _					
					freqMeasInputError  As Byte, _					
					offsetLimitVrms     As Byte, _
					offsetLimitI1       As Byte, _					
					offsetLimitI2       As Byte, _
					offsetLimitI3       As Byte, _
					refErrorVrms        As Byte, _
					refErrorI1          As Byte, _
					refErrorI2          As Byte, _
					refErrorI3			As Byte, _	
					refErrorStdDevVrms  As Byte, _ 
					refErrorStdDevI1    As Byte, _
					refErrorStdDevI2    As Byte, _
					refErrorStdDevI3    As Byte, _
					sdCardError         As Byte, _
					rtcGPSError         As Byte, _					
					MainBatteryVoltsErr As Byte, _
					VBatVoltsErr        As Byte, _
					VRefDiffVoltsErr    As Byte, _
					ProcessorTempErr    As Byte, _
					Quality			    As Byte _
					)
    
	Public rtData_s As rtData_t
	
	'*********************************************************************************
	' Realtime data

	Type rtAlarm_t(	flashMemError       As Byte, _
					freqMeasRefClkError As Byte, _
					realTimeProcError  	As Byte, _					
					freqMeasInputError  As Byte, _					
					offsetLimitVrms     As Byte, _
					offsetLimitI1       As Byte, _					
					offsetLimitI2       As Byte, _
					offsetLimitI3       As Byte, _
					refErrorVrms        As Byte, _
					refErrorI1          As Byte, _
					refErrorI2          As Byte, _
					refErrorI3			As Byte, _	
					refErrorStdDevVrms  As Byte, _ 
					refErrorStdDevI1    As Byte, _
					refErrorStdDevI2    As Byte, _
					refErrorStdDevI3    As Byte, _
					sdCardError         As Byte, _
					rtcGPSError         As Byte, _					
					MainBatteryVoltsErr As Byte, _
					VBatVoltsErr        As Byte, _
					VRefDiffVoltsErr    As Byte, _
					ProcessorTempErr    As Byte, _
					Quality			    As Byte, _
					PSM_DBConn  		As Boolean)
    
	Public rtAlarms As rtAlarm_t

#End Region	

	Dim tempInt(2) As Int
	Dim buffTempInt(16) As Byte
	Dim buffTempIntForFloat(14 * 4) As Byte

	Public SQL As SQL
	Dim databseInsertInProgress As Boolean
	Dim pmonDBIsConnected As Boolean

	'ALARMS	
	Public alarmsIsInitialised As Boolean
'	Private Speaker As SpeechLib
'	Private SpeakerNoVoices As Int
'	Private SpeechTimer As Timer
	
	Public acPlaying As Boolean
	Public audibleAlarmsMute As Boolean
	Public audibleNotifyMute As Boolean
	Public displayUTC As Boolean
	
	Public alarmActiveEmailSent As Boolean
	Public lastSDCardStatus As Char

End Sub ' Globals


'======================================================================================
Sub NetWorkService_Create
	'This is the program entry point.
	alarmsIsInitialised = False
	lastSDCardStatus = -128
	acqRestartFlag = False
	
	calDate.Initialize

	' Create the pass code array for transmit to reduce network overhead
	Dim pc(1) As Int
	Dim tempInt(4) As Int
	Dim tempByte(6) As Byte

	TCPConvRx.LittleEndian = True
	TCPConvTx.LittleEndian = True
	
	pc(0) = utils.ConvertHexStringToInt(passCode) 'B4a doesn't do hex. Damn!!
	passcodeInt = pc(0)
	passCodeByteArray = TCPConvRx.IntsToBytes(pc)
	
	' Create the Get realtime data array as we will use this every 2 to 2 seconds
	'Include pass code at start of data packet
	TCPConvRx.ArrayCopy(passCodeByteArray, 0, txBuffGetRealTimePowerData, 0, 4)
			
	'Include the Command group in the data packet
	tempInt(0) = 20					' Data Length
	tempInt(1) = GRP_GET_INST_DATA 	' Cmd Group
	tempInt(2) = CMD_1_GET_PWR_DATA	' Cmd Number
	tempInt(3) = 0xABCDEF12			' Data Flag
	
	tempByte = TCPConvRx.IntsToBytes(tempInt)
	
	' Now append to transmit buffer
	TCPConvRx.ArrayCopy(tempByte, 0, txBuffGetRealTimePowerData, 4, 16)

	'Set the date and time formats
	DateTime.DateFormat = "YYYY-MM-DD"
	DateTime.TimeFormat = "HH:MM:SS.SSS"
	
	'Open the Real Time Data SQLite Database

	Try
		SQL.InitializeSQLite(dbPath, psmDB_Filename, False )
		pmonDBIsConnected = True
'		Main.tb2.Font  = fx.CreateFontAwesome(16)
'		Main.tb2.Text  = Chr(0xF0C1)
'		Main.tb2.TextColor = fx.Colors.From32Bit(0xFF039D00)
	Catch
		pmonDBIsConnected = False
'		Main.tb2.Font  = fx.CreateFontAwesome(16)
'		Main.tb2.Text  = Chr(0xF127)
'		Main.tb2.TextColor = fx.Colors.From32Bit(0xFFFF0000)
	End Try

	'Start the NWrk and connect a socket for comms with the embedded server
	connectTCPSocket

	rtData_s.Initialize
	
	dateTimeConversions.initDateTimeConversions

	startTime = DateTime.Time(DateTime.Now)
	
	'Initialise the timer that requests power monitor realtime data
	If NWrkRealTimeDataTmr.IsInitialized = False Then
		NWrkRealTimeDataTmr.Initialize("tmr_NWrkRealTimeData", 2000)
	End If
	
'	'Initialise the network error beep timer 
'	If NetworkErrorBeepTmr.IsInitialized = False Then
'		NetworkErrorBeepTmr.Initialize("tmrBeep", 2000) 
'	End If	
End Sub


'======================================================================================
Sub connectTCPSocket
	If TCPSocket.IsInitialized Then
		TCPSocket.Close
	Else
		TCPSocket.Initialize("rxTCP")
	End If

	Try
		TCPSocket.Connect(ipAddress, port, 5000)
		wait for TCPSocket_Connected(Successful As Boolean)
	Catch
		If logOn Then Log("TSocket Connect: " & ipAddress & " : " & port & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now))
	End Try	

	'Start the realtime data acquisition timer
	If NWrkRealTimeDataTmr.IsInitialized = True Then
		NWrkRealTimeDataTmr.Enabled = True
	End If
End Sub

'======================================================================================
Sub rxTCP_Connected (Successful As Boolean)
	If Successful = True Then
		networkDown = False
		audioNotify
'		 sendEmailMsg("Power Monitor TCP Connected At " & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now), _ 
'					 "TSocket Connect: " & ipAddress & " : " & port & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now), False)
		If tcpStream.IsInitialized = False Then
			tcpStream.InitializePrefix(TCPSocket.InputStream, False, TCPSocket.OutputStream, "tcpStream")
'			Main.lblStatus.Text = "Server Connected " & ipAddress & ":" & port & "  @ " & DateTime.Date(DateTime.Now) 
'			Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors
			
			'Start the realtime data acquisition timer
			If NWrkRealTimeDataTmr.IsInitialized = True Then
				NWrkRealTimeDataTmr.Enabled = True
			End If
	
			'Start the comms timeout timer
			If CmdTimeoutTmr.IsInitialized = False Then
				CmdTimeoutTmr.Initialize("tmr_CmdTimeoutTmr", 2200)
				CmdTimeoutTmr.Enabled = False 'Don't start until we send a command to the server
			End If
		End If
	Else
		networkDown = True
		audioAlarm
'		sendEmailMsg("Power Monitor Warning: TCP Connection Failed At " & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now), _
'					 "TSocket Failure: " & ipAddress & " : " & port & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now), True)		
		tcpStream.Close 'Close the stream
		TCPSocket.Close 'Close the socket 

		'Stop the realtime data acquisition timer
		If NWrkRealTimeDataTmr.IsInitialized = True Then
			NWrkRealTimeDataTmr.Enabled = False
		End If
	
	
'		xui.MsgboxAsync("Could Not Connect TCPSocket", "Establish Comms")
'		Main.lblStatus.Text = "Server Error 1: Cannot connect to " & ipAddress & ":" & port & "  @ " & DateTime.Date(DateTime.Now)
'		Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors
		
		Sleep(1000)
		connectTCPSocket
		
	End If
End Sub


'======================================================================================
Sub tmr_NWrkRealTimeData_Tick
	If NWrkTransactionInProgress = True Then Sleep(50)
	sendCommand(GRP_GET_INST_DATA, CMD_1_GET_PWR_DATA)
	Wait For CanContinue
End Sub

'======================================================================================
Sub tmr_CmdTimeoutTmr_Tick
'	Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors
'	Log("Tx ERROR CMD TIMEOUT: " & ipAddress & " : " & port & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now))
	CmdTimeoutTmr.Enabled = False
'	NWrkTransactionInProgress = False
	NWrkRealTimeDataTmr.Enabled = False
	tcpStream.Close 'Close the stream
	TCPSocket.Close 'Close the socket
	
	networkDown = True
	audioAlarm
'	SpeakerSay("Warning, Server No Response.", 0)
'	sendEmailMsg("Power Monitor Warning: Server No Response At " & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now), _
'					 "TSocket Failure: " & ipAddress & " : " & port & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now), True)	
	Sleep(2200)	'Give the network some time to re-establish

	connectTCPSocket 'Try to reconnect the socket
End Sub


'======================================================================================
Sub tmrBeep_Tick
	
End Sub

'======================================================================================
Sub sendCommand(cmdGroup As Short, cmdNum As Short)

	Dim result = NW_OK As Int
	
'	' Wait for previous transactions to complete
'	Do While NWrkTransactionInProgress = True 
'		Sleep(10)
'	Loop

	CmdTimeoutTmr.Enabled = True
	noServerRequests = noServerRequests + 1
	
	msgSerialNo =  msgSerialNo + 1
	NWrkTransactionInProgress = True
	
	Select cmdGroup
		Case GRP_GET_INST_DATA	' Get Parameters from Controller
			If cmdNum = CMD_1_GET_PWR_DATA Then
'				Log("Output Queue Size: "  & tcpStream.OutputQueueSize & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now))
				If TCPSocket.Connected And tcpStream.OutputQueueSize == 0 Then
'					Log("Tx OK 1: " & ipAddress & " : " & port & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now))
					If	tcpStream.Write(txBuffGetRealTimePowerData) = False Then
						tcpStream.Close
						TCPSocket.Close
'						Main.lblStatus.Text = "Server Error 3: Cannot connect to " & ipAddress & ":" & port & "  @ " & DateTime.Date(DateTime.Now)
'						Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors & "  @ " & DateTime.Date(DateTime.Now)
'							xui.MsgboxAsync("TCP Stream Write Error", "Send sendCommand")
						noServerErrors = noServerErrors + 1
						NWrkRealTimeDataTmr.Enabled = False

'						Log("Tx ERROR 2: " & ipAddress & " : " & port & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now))
					Else
'						Log("Tx OK: " & ipAddress & " : " & port & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now))
'						Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors & "  @ " & DateTime.Date(DateTime.Now)
						'Log("Tx OK: " & ipAddress & " : " & port & "  " & DateTime.Date(DateTime.Now))
					End If
				Else
					NWrkRealTimeDataTmr.Enabled = False
					tcpStream.Close
					TCPSocket.Close

					'				#If LOGGING_ON
'					Log("Tx Error 1: " & ipAddress & " : " & port & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now))
					'				#End If
'					Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors  & "  @ " & DateTime.Date(DateTime.Now)
				End If
			Else
				result = transmitCommandGrp1(cmdNum)
			End If
		Case GRP_SEND_CMD_NO_DATA
			transmitCommandGrp2(cmdNum)
	
	End Select
End Sub


'======================================================================================
Sub transmitCommandGrp1(cmdNum As Short) As Int

	Dim txBuffGetRealTimePowerData(10) As Byte

	Select cmdNum
		Case CMD_1_GET_PWR_DATA	' Get Realtime Power Data

			If tcpStream.Write(txBuffGetRealTimePowerData) = False Then
'				Main.lblStatus.Text = "Server Error 5: Cannot connect to " & ipAddress & ":" & port & "  @ " & DateTime.Date(DateTime.Now) & " " &DateTime.Time(DateTime.Now)
'				Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors
'				xui.MsgboxAsync("TCP Stream Write Error", "Send sendCommand")
				noServerErrors = noServerErrors + 1
			Else
'				Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors  & "  @ " & DateTime.Date(DateTime.Now) & " " &DateTime.Time(DateTime.Now)
			End If
			#If LOGGING_ON
		'			Log("Tx: " & strBuff)
			#End If			
	End Select
	
	Return NW_OK
End Sub


'======================================================================================
Sub transmitCommandGrp2(cmdNum As Short) As Int

	Dim txBuff(20) As Byte
	Dim tempInt(4) As Int
	Dim tempByte(20) As Byte

	TCPConvRx.ArrayCopy(passCodeByteArray, 0, txBuff, 0, 4)
	tempInt(0) = 20						' Data Length
	tempInt(1) = GRP_SEND_CMD_NO_DATA 	' Cmd Group

	Select cmdNum
		Case CMD_2_MOUNT_SD_CARD				' Get Realtime Power Data
			tempInt(2) = CMD_2_MOUNT_SD_CARD	' Cmd Number

		Case CMD_2_DISMOUNT_SD_CARD	' Get Realtime Power Data
			tempInt(2) = CMD_2_DISMOUNT_SD_CARD	' Cmd Number

	End Select
	
	tempInt(3) = msgSerialNo				' Data Flag
	
	tempByte = TCPConvTx.IntsToBytes(tempInt)
	
	' Now append to transmit buffer
	TCPConvTx.ArrayCopy(tempByte, 0, txBuff, 4, 16)
	
	If TCPSocket.Connected And tcpStream.OutputQueueSize == 0 Then
		If tcpStream.Write(txBuff) = False Then
'			Main.lblStatus.Text = "Server Error 5: Cannot connect to " & ipAddress & ":" & port & "  @ " & DateTime.Date(DateTime.Now) & " " &DateTime.Time(DateTime.Now)
'			Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors
'			xui.MsgboxAsync("TCP Stream Write Error", "Send sendCommand")
			noServerErrors = noServerErrors + 1
		Else
'			Main.lblServerStats.Text = "Number of requests = " & noServerRequests & "  Number of errors = " & noServerErrors  & "  @ " & DateTime.Date(DateTime.Now) & " " &DateTime.Time(DateTime.Now)
		End If
			#If LOGGING_ON
	'			Log("Tx: " & strBuff)
			#End If	
	End If
	
	Return NW_OK
End Sub


'======================================================================================
Sub tcpStream_NewData (buffer() As Byte)
	CmdTimeoutTmr.Enabled = False
'	NetworkErrorBeepTmr.Enabled = False
	
	'If se have restarted then send message ipc server
	If acqRestartFlag Then
		Main.cmdWrite.dt = DateTime.Now
		Main.astreamWriteData
	End If
	
	If bypassTCPSteamProcessing = True Then
		Return
	End If
	
'	Log("Rx: " & ipAddress & " : " & port & "  " & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now))
'	Log(" ")
'	endTime = DateTime.Time(DateTime.Now)
'
	CmdTimeoutTmr.Enabled = False 'Reset comms timeout timer

	'Check the message is valid and which type it is
	buffTempInt(0) = buffer(0)
	buffTempInt(1) = buffer(1)
	buffTempInt(2) = buffer(2)
	buffTempInt(3) = buffer(3)
	
	buffTempInt(4) = buffer(4)
	buffTempInt(5) = buffer(5)
	buffTempInt(6) = buffer(6)
	buffTempInt(7) = buffer(7)
		
	buffTempInt(8) = buffer(8)
	buffTempInt(9) = buffer(9)
	buffTempInt(10) = buffer(10)
	buffTempInt(11) = buffer(11)
		
	buffTempInt(12) = buffer(12)
	buffTempInt(13) = buffer(13)
	buffTempInt(14) = buffer(14)
	buffTempInt(15) = buffer(15)

	tempInt = TCPConvRx.IntsFromBytes(buffTempInt)

	
	If tempInt(0) <> passcodeInt Then
'			ToastMessageShow("Communication Error Occurred", True)
		Return
	End If

	'Process the data based on the data type
	Select tempInt(2)
		'------------------------------------------------------------------------------
		Case GRP_GET_INST_DATA	' Set Parameters - Handle acknowledge
		Select tempInt(3)
			Case CMD_1_GET_PWR_DATA
				If buffer.Length <> CMD_1_GET_PWR_DATA_LEN Then
					Return
				End If
			
				'Get the Julian Date and System Frequency - both doubles
				'--------------------------------------------------------------------------
				TCPConvRx.ArrayCopy(buffer, 20, buffTempInt, 0, 16)
				tempDouble = TCPConvRx.DoublesFromBytes(buffTempInt)
			
				jTime = (tempDouble(0) - Floor(tempDouble(0))) * 24
				
				#If LOGGING_ON
'				'Log("1. A Streams New Data " & buffer.Length & " bytes " & maths.SecondsBetweenTimes(startTime, endTime))
'				Log(maths.SecondsBetweenTimes(startTime, endTime) & ", " & tempDouble(0) & ", " & ((tempDouble(0) - lastDataJulianDate) * 86400))
				startTime = endTime
				lastDataJulianDate = tempDouble(0)
				#End If

				'Get the floating point amd double vars bytes and covert them
				'--------------------------------------------------------------------------
				TCPConvRx.ArrayCopy(buffer, 36, buffTempIntForFloat, 0, 14 * 4)
				tempFloat = TCPConvRx.FloatsFromBytes(buffTempIntForFloat)


				rtData_s.jTimeEmbed 			= tempDouble(0)         '8
				rtData_s.Frequency 				= tempDouble(1)			'16
		
				rtData_s.Vrms					= tempFloat(0)			'20
				rtData_s.RoCoF					= tempFloat(1)			'24
				rtData_s.RoCoVrms				= tempFloat(2)			'28
				rtData_s.I1rms					= tempFloat(3)			'32
				rtData_s.I2rms					= tempFloat(4)			'36
				rtData_s.I3rms					= tempFloat(5)			'40
				rtData_s.P1						= tempFloat(6)  / 1000  '44
				rtData_s.P2						= tempFloat(7) 	/ 1000	'48
				rtData_s.P3						= tempFloat(8) 	/ 1000	'52
				rtData_s.Q1						= tempFloat(9) 	/ 1000	'56
				rtData_s.Q2						= tempFloat(10) / 1000	'60
				rtData_s.Q3						= tempFloat(11) / 1000	'64
				rtData_s.CPUTemp				= tempFloat(12)			'68
				rtData_s.MainBatVolts			= tempFloat(13)			'72

				rtData_s.flashMemError			= buffer(92)			'76 + 18 = 92
				rtData_s.freqMeasRefClkError	= buffer(93)
				rtData_s.realTimeProcError		= buffer(94)
				rtData_s.freqMeasInputError		= buffer(95)
				rtData_s.offsetLimitVrms		= buffer(96)
				rtData_s.offsetLimitI1			= buffer(97)
				rtData_s.offsetLimitI2			= buffer(98)
				rtData_s.offsetLimitI3			= buffer(99)
				rtData_s.refErrorVrms			= buffer(100)
				rtData_s.refErrorI1				= buffer(101)
				rtData_s.refErrorI2				= buffer(102)
				rtData_s.refErrorI3				= buffer(103)
				rtData_s.refErrorStdDevVrms		= buffer(104)
				rtData_s.refErrorStdDevI1		= buffer(105)
				rtData_s.refErrorStdDevI2		= buffer(106)
				rtData_s.refErrorStdDevI3		= buffer(107)
				rtData_s.sdCardError			= buffer(108)
				rtData_s.rtcGPSError			= buffer(109)
				rtData_s.MainBatteryVoltsErr	= buffer(110)
				rtData_s.VBatVoltsErr			= buffer(111)
				rtData_s.VRefDiffVoltsErr		= buffer(112)
				rtData_s.ProcessorTempErr		= buffer(113)
				rtData_s.Quality				= buffer(114)
				
				'Add record to database
				insert_realtimeData
'				setSDCardStatus(rtData_s.sdCardError)

					
					calDate = dateTimeConversions.JD2CAL (rtData_s.jTimeEmbed )
					
'					Log("Date: " & calDate.lpnYear & "-" & calDate.lpnMn & "-" & calDate.lpnDy & " " & calDate.lpnHr & ":" & calDate.lpnMn & ":" & calDate.lpnmS)
'					Log("Vrms = " & rtData_s.Vrms & " Freq = " & rtData_s.Frequency & " I1 = " &  rtData_s.I1rms  & " I2 = " &  rtData_s.I2rms  & " I1 = " &  rtData_s.I3rms)
'					Log("P1 = " & rtData_s.P1 & " P2 = " & rtData_s.P2 & " P3 = " &  rtData_s.P3)
				CallSubDelayed(Me, "CanContinue")
				NWrkTransactionInProgress = False
			End Select	
			'------------------------------------------------------------------------------
		Case GRP_SEND_CMD_NO_DATA
			Select tempInt(3)
				Case CMD_2_MOUNT_SD_CARD
					
				
				Case CMD_2_DISMOUNT_SD_CARD
					
				Case Else
						
			End Select	
	End Select
End Sub


'================================================================================================
Sub insert_realtimeData
	Dim dateTimeStr As String
	
	dateTimeStr = DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now)
	If databseInsertInProgress = False Then
		Try
			DateTime.DateFormat = "YYYY-MM-DD HH:MM:SS.SSS"
			databseInsertInProgress = True
			SQL.BeginTransaction
			SQL.ExecNonQuery2("INSERT INTO tblRealTimeData VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", _
								Array As Object( _
								rtData_s.jTimeEmbed, _ 
								rtData_s.Frequency, _
								rtData_s.Vrms, _
								rtData_s.RoCoVrms, _									
								rtData_s.RoCoF, _
								rtData_s.I1rms, _										
								rtData_s.I2rms, _
								rtData_s.I3rms, _
								rtData_s.P1, _
								rtData_s.P2, _
								rtData_s.P3, _
								rtData_s.Q1, _
								rtData_s.Q2, _
								rtData_s.Q3, _									
								rtData_s.CPUTemp, _
								rtData_s.MainBatVolts, _	
								rtData_s.flashMemError, _
								rtData_s.freqMeasRefClkError, _
								rtData_s.realTimeProcError, _
								rtData_s.freqMeasInputError, _
								rtData_s.offsetLimitVrms, _
								rtData_s.offsetLimitI1, _
								rtData_s.offsetLimitI2, _
								rtData_s.offsetLimitI3, _
								rtData_s.refErrorVrms, _
								rtData_s.refErrorI1, _
								rtData_s.refErrorI2, _
								rtData_s.refErrorI3, _
								rtData_s.refErrorStdDevVrms, _
								rtData_s.refErrorStdDevI1, _
								rtData_s.refErrorStdDevI2, _
								rtData_s.refErrorStdDevI3, _
								rtData_s.sdCardError, _
								rtData_s.rtcGPSError, _
								rtData_s.MainBatteryVoltsErr, _
								rtData_s.VBatVoltsErr, _
								rtData_s.VRefDiffVoltsErr, _
								rtData_s.ProcessorTempErr, _
								rtData_s.Quality, _
								dateTimeStr _
								))
			SQL.TransactionSuccessful
		Catch
'			Log(LastException.Message)
			'TODO
		End Try
	Else
		Sleep(10) ' Wait to give db Insert time to complete
	End If
	databseInsertInProgress = False
End Sub



'============================================================================================
Public Sub doFullCheckPoint(dbArg As SQL, path As String, dbName As String, closeAfterCheckPoint As Boolean) As Boolean
	'Close the database to enable checkpointing
	dbArg.Close
	
	'Reopen database
	dbArg.InitializeSQLite(path, dbName, False)

 	'Checkpoint and trucncate WAL file to 0 bytes
	Dim qryStr As String = "PRAGMA wal_checkpoint(TRUNCATE);"
	Try
		dbArg.ExecNonQuery(qryStr)
	Catch
		Log(LastException)
		If logOn Then Log("Checkpoint TRUNCATE = Failed")
		Return False
	End Try

	'Do we want to close the database?
	If logOn Then Log("Checkpoint TRUNCATE = OK")
	If closeAfterCheckPoint = True Then
		dbArg.Close
	End If
	
	Return True
End Sub


'============================================================================================
public Sub openDB(dbArg As SQL, path As String, dbName As String)
	dbArg.InitializeSQLite(path, dbName, False)
End Sub


'============================================================================================
Public Sub testDBConnection(cmdWriteArg As cmdData_t, dbArg As SQL) As Boolean
	Dim resSet As ResultSet
	
	Dim sqlStr As String = _ 
	$"SELECT
 		julianDateUTC,
     	Vrms,
	 	frequency,
     	ProcessorTemp,
     	mainBatteryVolts,
     	Quality
	FROM tblRealTimeData
	ORDER BY julianDateUTC DESC LIMIT 1"$
	
	Try
		resSet = dbArg.ExecQuery(sqlStr)
	Catch
		If logOn Then Log(LastException)
		Return False
	End Try

	
	If resSet.NextRow = False Then
		If logOn Then Log("No records found.")
		Return False
	End If
	
	cmdWriteArg.jDate = resSet.GetDouble("julianDateUTC")
	cmdWriteArg.Freq = resSet.GetDouble("frequency")
	cmdWriteArg.Vrms = resSet.GetDouble("Vrms")
	cmdWriteArg.ProcessorTemp = resSet.GetDouble("ProcessorTemp")
	cmdWriteArg.mainBatteryVolts = resSet.GetDouble("mainBatteryVolts")
	cmdWriteArg.Quality = resSet.GetDouble("Quality")
	
	Return True	
End Sub	

'Sub sendEmailMsg(emailSubject As String, emailBody As String, alarmFlag As Boolean)
'#if Release	
'	If audibleNotifyMute = False Then
'		Dim SMTP As SMTP
'		If (alarmActiveEmailSent = False And alarmFlag = True) Or  (alarmFlag = False) Then
'			SMTP.Initialize("mail.aussiebroadband.com.au", 587, "rjg@wideband.net.au", "35toyota", "SMTP")
'			SMTP.StartTLSMode = True
'			SMTP.MailFrom="powerMonAlarm@wideband.net.au"
'		    SMTP.HtmlBody=True
'			SMTP.Body = emailBody
'		    Log(SMTP.Body) ' yes, I see all the HTML body in the log
'			SMTP.Subject = emailSubject
'			SMTP.To.Add ("rjg@wideband.net.au")
'		    SMTP.UseSSL=True
'		    SMTP.AuthMethod=SMTP.AUTH_LOGIN
'		    SMTP.Send
'			alarmActiveEmailSent = True
'		End If
'	End If 
'	If alarmActiveEmailSent = True And alarmFlag = False Then alarmActiveEmailSent = False
'#end if	
'End Sub

Sub audioNotify
	If audibleNotifyMute = False Then
		Dim AC As AudioClip = AudioClip_Static.NewAudioClip(File.GetUri(File.DirAssets,"Ding-dong.wav"))
		If audibleNotifyMute = False Then
			AC.SetCompleteListener(Me,"AC")
			AC.Play
			acPlaying = True
		End If
	End If	
End Sub

Sub audioAlarm
	If audibleAlarmsMute = False Then
		Dim AC As AudioClip = AudioClip_Static.NewAudioClip(File.GetUri(File.DirAssets,"Basic-ringtone.mp3"))
		AC.SetCompleteListener(Me,"AC")
		AC.Play
		acPlaying = True
	End If
End Sub

Public Sub AC_Complete
	acPlaying = False
End Sub

